@connect /
set echo on
set timing on
set pagesize 1000
/*
we'll look at the difference between USING a feature that others may 
not have, vs using "ansi sql"
*/
drop table emp;
create table emp as select * from scott.emp;
alter table emp modify deptno not null;

column pct_dept format 99.9
column pct_overall format 99.9
break on deptno skip 1
/*
Need a report to show cumulative salary, pct of salary in deptno by empno,
pct of salary by empno over the entire "company"
*/
pause
set pause on
select deptno,
       ename,
       sal,
       sum(sal) over 
	      (partition by deptno order by sal,ename) cum_sal,
       round(100*ratio_to_report(sal)
                over (partition by deptno), 1 ) pct_dept,
       round(100*ratio_to_report(sal) over () , 1 ) pct_overall
  from emp look_for_me
 order by deptno, sal
/
pause

select emp.deptno,
       emp.ename,
       emp.sal,
       sum(emp4.sal) cum_sal,
       round(100*emp.sal/emp2.sal_by_dept,1) pct_dept,
       round(100*emp.sal/emp3.sal_overall,1) pct_overall
  from emp,
       (select deptno, sum(sal) sal_by_dept
          from emp
         group by deptno ) emp2,
       (select sum(sal) sal_overall
          from emp ) emp3,
       emp emp4
 where emp.deptno = emp2.deptno
   and emp.deptno = emp4.deptno
   and (emp.sal > emp4.sal or
         (emp.sal = emp4.sal and emp.ename >= emp4.ename))
 group by emp.deptno, emp.ename, emp.sal,
       round(100*emp.sal/emp2.sal_by_dept,1),
       round(100*emp.sal/emp3.sal_overall,1)
 order by deptno, sal
/
set pause off
pause

/*
works great so far right?  Lets add more employees
*/
exec gen_data( 'EMP', 8000 );

analyze table emp compute statistics 
for table for all indexes for all indexed columns;

alter session set sql_trace=true;
set autotrace traceonly
pause
set pause on
select deptno,
       ename,
       sal,
       sum(sal) over 
	      (partition by deptno order by sal,ename) cum_sal,
       round(100*ratio_to_report(sal)
                over (partition by deptno), 1 ) pct_dept,
       round(100*ratio_to_report(sal) over () , 1 ) pct_overall
  from emp look_for_me
 order by deptno, sal
/
pause
set pause off
select emp.deptno,
       emp.ename,
       emp.sal,
       sum(emp4.sal) cum_sal,
       round(100*emp.sal/emp2.sal_by_dept,1) pct_dept,
       round(100*emp.sal/emp3.sal_overall,1) pct_overall
  from emp,
       (select deptno, sum(sal) sal_by_dept
          from emp
         group by deptno ) emp2,
       (select sum(sal) sal_overall
          from emp ) emp3,
       emp emp4
 where emp.deptno = emp2.deptno
   and emp.deptno = emp4.deptno
   and (emp.sal > emp4.sal or
         (emp.sal = emp4.sal and emp.ename >= emp4.ename))
 group by emp.deptno, emp.ename, emp.sal,
       round(100*emp.sal/emp2.sal_by_dept,1),
       round(100*emp.sal/emp3.sal_overall,1)
 order by deptno, sal
/
