@connect u1/u1

set echo on
/*
first, we'll look at autotrace and it's output for explain plans, comparing
the different effects of different analyzes

drop table t;
create table t as select * from all_objects;
create index t_idx on t(object_id);
*/
analyze table t delete statistics;

analyze table t compute statistics
for table
for all indexes;

set autotrace traceonly explain
select * from t where object_id = 55;
pause
analyze table t compute statistics 
for table 
for all indexes 
for all indexed columns;
select * from t where object_id = 55;
pause
set autotrace off

/*
Next we'll look at autotrace statistics -- showing in this case the effect
of arraysize on consistent gets (and hence latching for example)

start by looking at the number of blocks in T
*/
select blocks, num_rows/blocks from user_tables where table_name='T';
pause
set autotrace traceonly statistics
set arraysize 10
select * from t;
pause
set arraysize 100
select * from t;
pause
set arraysize 500
select * from t;
pause
set autotrace off

drop table emp;
drop table dept;
drop table bonus;
create table emp as select * from scott.emp;
create table dept as select * from scott.dept;
create table bonus as select * from scott.bonus;
alter table emp add constraint emp_pk primary key(empno);
alter table dept add constraint dept_pk primary key(deptno);
create index bonus_idx on bonus(ename);

analyze table emp compute statistics;
analyze table dept compute statistics;
analyze table bonus compute statistics;
pause

delete from plan_table;

explain plan for
select *
  from emp, dept
 where emp.deptno = dept.deptno
   and not exists ( select null from bonus where ename = emp.ename );

select plan_table_output 
  from table(dbms_xplan.display('plan_table',null,'serial'));

delete from plan_table;
